namespace Gen7 {
    class AuraBreak : PkmnScript {
        void OverrideBasePower(ExecutingMove@ move, Pokemon@, uint8, uint8 &inout power){
            auto typeLib = move.User.Battle.Library.StaticLibrary.TypeLibrary;
            auto fairyType = typeLib.GetTypeId("fairy");
            auto darkType = typeLib.GetTypeId("dark");
            if (move.UseMove.Type == fairyType || move.UseMove.Type == darkType){
                power = uint8(power * 0.75f);
            }
        }
    }
}